"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Aspect = void 0;
const index_1 = require("../../index");
const objectDef_1 = require("./objectDef");
function Aspect(aspectTarget, match, priority) {
    return function (target) {
        (0, index_1.saveModule)(index_1.ASPECT_KEY, target);
        const aspectTargets = [].concat(aspectTarget);
        for (const aspectTarget of aspectTargets) {
            (0, index_1.attachClassMetadata)(index_1.ASPECT_KEY, {
                aspectTarget,
                match,
                priority,
            }, target);
        }
        (0, objectDef_1.Scope)(index_1.ScopeEnum.Singleton)(target);
        (0, index_1.Provide)()(target);
    };
}
exports.Aspect = Aspect;
//# sourceMappingURL=aspect.js.map